<?php
/**
 * Copyright 2019 PaedDr. Martin Sereday [www.cmsimple.sk]
 *
 * xhRepo_xmlWriter
 * Version 1.6
 * creates XML-Files for teplad-xml-1.1
 *
 * xhRepo_xmlWriter is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * xhRepo_xmlWriter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. <http://www.gnu.org/licenses/>
 */
 
//error_reporting(E_ALL);
//ini_set('display_errors', 1);

//******************************************************************************
include_once('./config.php');
//******************************************************************************
$url_blacklist = array('localhost', '127.0.0.1', '::1');
if((!in_array($_SERVER['HTTP_HOST'], $url_blacklist)) && ($xml_url_auto == 'on')) {
    $xmlfolderURL = 'http' . (!empty($_SERVER['HTTPS']) ? 's' : '') 
                  . '://' . $_SERVER['HTTP_HOST'] 
                  . str_replace(array('/index.php','/writer'), '', $_SERVER['PHP_SELF'])
                  . '/data/';
} else {
    $xmlfolderURL = '';
}
//******************************************************************************
if((isset($_GET['delFile'])) && ($_GET['delFile'] != '')) {
    $delFile = basename($_GET['delFile']);
    if(preg_match('//u', $delFile)) {
        unlink($xmlPath . '/' . $delFile);
        $html_file = substr($delFile, 0, -4);
        $html_file = $html_file . '.html';
        if(file_exists($xmlPath . '/' . $html_file)) {
            unlink($xmlPath . '/' . $html_file);
        }
    }
    header('location:./');
    exit;
}

if((isset($_GET['xmlFileName'])) && ($_GET['xmlFileName'] != '')) {
    $xmlFileName = basename($_GET['xmlFileName']);
    $xmlFile = $xmlPath . '/' . $xmlFileName;
}
//******************************************************************************
function getFilesXML() {

    global $xmlPath;

    $xml_files_array = array();
    $allfiles = scandir($xmlPath);
    foreach($allfiles as $file_tmp) {
        if(($file_tmp != '.') 
        && ($file_tmp != '..') 
        && ($file_tmp != '.htaccess') 
        && (substr($file_tmp, -4) == '.xml')) {
            $xml_files_array[] = $file_tmp;
        }
    }
    if(!empty($xml_files_array)) {
        natsort($xml_files_array);
        $xml_files_list = '<table>';
        foreach($xml_files_array as $xml_file_tmp) {
            $xml_files_list .= '<tr>';
            $xml_files_list .= '<td><a class="xhButtonLight xhButtonEdit" title="edit document" href="'
                            . $_SERVER['PHP_SELF']
                            . '?xmlFileName='
                            . $xml_file_tmp
                            . '">'
                            . $xml_file_tmp
                            . '&nbsp;&nbsp;<span class="fileDate"> '
                            . date('Y-m-d H:i', filemtime($xmlPath . '/' . $xml_file_tmp))
                            . '</span></a></td>';
            $xml_files_list .= '<td>';
            $html_tmp_file = substr($xml_file_tmp, 0, -4) . '.html';
            if(file_exists($xmlPath . '/' . $html_tmp_file)) {
                $xml_files_list .= '<a target="_blank" class="xhButtonLight xhButtonPreview" title="html-Preview of the collected data" href="'
                                . $xmlPath . '/' . $html_tmp_file
                                . '">&nbsp;</a></td>';
            }
            $xml_files_list .= '</td>';
            $xml_files_list .= '<td><a class="xhButtonLight xhButtonTrash" title="delete document" href="'
                            . $_SERVER['PHP_SELF']
                            . '?delFile='
                            . $xml_file_tmp
                            . '" onclick="if (!confirm(\'Really delete this file?\')) return false;">&nbsp;</a></td>';
            $xml_files_list .= '</tr>';
        }
        $xml_files_list .= '</table>';
    } else {
        $xml_files_list = '<p class="xhInfo">No files found in ' . $xmlPath . '.</p>';
    }
    return $xml_files_list;
}
//******************************************************************************
if((isset($xmlFile)) && (file_exists($xmlFile))) {
    $xml = simplexml_load_file($xmlFile);
// declare the php variables from xml
    $name                       = $xml->name;
    $name_type                  = $xml->name['type'];
    $version                    = $xml->version;
    $date_version               = str_replace('.', '-', $xml->date_version);
    $tags                       = $xml->tags;
    $coder                      = $xml->coder;
    $download_url               = $xml->url->download_url;
    $coder_url                  = $xml->url->coder_url;
    $demo_url                   = $xml->url->demo_url;
    $compatibility              = $xml->compatibility;
    $php_ver                    = $xml->php_ver;
    $license                    = $xml->license;
    $description_en             = $xml->descriptions->description[0];
    if(isset($xml->descriptions->description[1])) {
        $description_de         = $xml->descriptions->description[1];
    } else {
        $description_de         = '';
    }
    if(isset($xml->screenshots->screenshot[0])) {
        $screenshot1            = $xml->screenshots->screenshot[0];
        $screenshotAlt1         = $xml->screenshots->screenshot[0]['view'];
    } else {
        $screenshot1            = '';
        $screenshotAlt1         = '';
    }
    if(isset($xml->screenshots->screenshot[1])) {
        $screenshot2            = $xml->screenshots->screenshot[1];
        $screenshotAlt2         = $xml->screenshots->screenshot[1]['view'];
    } else {
        $screenshot2            = '';
        $screenshotAlt2         = '';
    }
    if(isset($xml->screenshots->screenshot[2])) {
        $screenshot3            = $xml->screenshots->screenshot[2];
        $screenshotAlt3         = $xml->screenshots->screenshot[2]['view'];
    } else {
        $screenshot3            = '';
        $screenshotAlt3         = '';
    }
    if(isset($xml->screenshots->screenshot[3])) {
        $screenshot4            = $xml->screenshots->screenshot[3];
        $screenshotAlt4         = $xml->screenshots->screenshot[3]['view'];
    } else {
        $screenshot4            = '';
        $screenshotAlt4         = '';
    }
    if(isset($xml->screenshots->screenshot[4])) {
        $screenshot5            = $xml->screenshots->screenshot[4];
        $screenshotAlt5         = $xml->screenshots->screenshot[4]['view'];
    } else {
        $screenshot5            = '';
        $screenshotAlt5         = '';
    }
    if(isset($xml->screenshots->screenshot[5])) {
        $screenshot6            = $xml->screenshots->screenshot[5];
        $screenshotAlt6         = $xml->screenshots->screenshot[5]['view'];
    } else {
        $screenshot6            = '';
        $screenshotAlt6         = '';
    }
    $logo                       = $xml->logo;
    $xml_url                    = $xml->xml_url;

} elseif((!isset($xmlFile)) || ((isset($xmlFile)) && (!file_exists($xmlFile)))) {
    $name                       = '';
    $name_type                  = '';
    $version                    = '';
    $date_version               = '';
    $tags                       = '';
    $coder                      = '';
    $download_url               = '';
    $coder_url                  = '';
    $demo_url                   = '';
    $compatibility              = '';
    $php_ver                    = '';
    $license                    = '';
    $description_en             = '';
    $description_de             = '';
    $screenshot1                = '';
    $screenshotAlt1             = '';
    $screenshot2                = '';
    $screenshotAlt2             = '';
    $screenshot3                = '';
    $screenshotAlt3             = '';
    $screenshot4                = '';
    $screenshotAlt4             = '';
    $screenshot5                = '';
    $screenshotAlt5             = '';
    $screenshot6                = '';
    $screenshotAlt6             = '';
    $logo                       = '';
    $xml_url                    = '';
}
//******************************************************************************
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>CMSimple_XH XML-Writer</title>
<link href="css/stylesheet.css" rel="stylesheet" type="text/css">
<!-- EDITOR -->
<script src="editor/scripts/widgEditor.js"></script>
<script>
document.write('<style>.noJS { display: none; }<\/style>')

function forceLower(strInput) {
    strInput.value=strInput.value.toLowerCase();
}
</script>
</head>
<body>
<div class="xhXMLWriter">
<div class="xhLogo"> </div>
<h1>CMSimple_XH &ndash; Repo-XML-Writer <span>(Version 1.6)</span></h1>
<p class="noJS xhFail">Please activate <strong>JavaScript</strong> in your browser!<br>Otherwise the data acquisition will not work correctly.</p>
<p class="xhBigger">A tool for creating an XML file for the CMSimple_XH repositories.</p>
<p>With this tool (which is only a form) you can create an XML file which is needed by XHRepo to publish your plugin, template or addon. This file must be uploaded to a public server, including the required images if you want to make them available. You can learn more about it on this <a href="https://www.cmsimple-xh.org/?Info-Repository" target="_blank">repo information page</a>.</p>
<hr>
<p>To change, select an existing document from the following list &hellip;</p>
<div class="xmlFileList">
<?php
//*****************
echo getFilesXML();
//*****************
?>
</div>
<?php
if((isset($xmlFileName)) && ($xmlFileName != '')) {
    echo '<p class="xhSuccess">The existing XML file <strong>' . $xmlFileName . '</strong> has been loaded and can now be edited.</p>';
}
if(!is_writable($xmlPath)) {
    echo '<p class="xhFail"><strong>Error!</strong><br>
The folder <strong>' . $xmlPath . '</strong> or is not writable (or does not exist)!</p>';
}
?>
<p>&hellip; or start with a completely</p>
<p><a class="xhButtonLight" title="Create a new document" href="./">NEW document</a></p>
<hr>
<h2>1. Basic information</h2>
<form class="xhForm" action="write_data.php" method="post">
<div class="xhFormGroup">
<label>Select repository</label>
<select class="xhFormControl" name="name_type" required>
<option value=""></option>
<option value="plugin" <?php if ($name_type == 'plugin') { echo 'selected'; } ?>>Plugins</option>
<option value="template" <?php if ($name_type == 'template') { echo 'selected'; } ?>>Templates</option>
<option  value="addon" <?php if ($name_type == 'addon') { echo 'selected'; } ?>>AddOns</option>
</select>
<p class="xhFormHelp">In which repo should your work appear &ndash; Plugins, Templates or AddOns? <span class="dataRequired">required</span></p>
</div>

<div class="xhFormGroup">
<label>Name</label>
<input class="xhFormControl" type="text" name="name" placeholder="e.g.: My_Plugin_XH" value="<?=$name;?>" required>
<p class="xhFormHelp">The full name of your work (case sensitive). <span class="dataRequired">required</span></p>
</div>

<div class="xhFormGroup">
<label>Latest version</label>
<input class="xhFormControl" type="text" name="version" placeholder="e.g.: 1.0beta1" value="<?=$version?>" required>
<p class="xhFormHelp">The current version of your work. <span class="dataRequired">required</span></p>
</div>

<div class="xhFormGroup">
<label>Date</label>
<input class="xhFormControl" type="date" name="date_version" placeholder="e.g.: 1.0beta1" value="<?=$date_version?>" required>
<p class="xhFormHelp">The release date of the current version. <span class="dataRequired">required</span></p>
</div>

<div class="xhFormGroup">
<label>Categories</label>
<input value="<?=$tags?>" class="xhFormControl" type="text" name="tags" placeholder="e.g.: admin,backend" required onkeyup="return forceLower(this);">
<p class="xhFormHelp">What category does your work belong to? Multiple entries are possible, separated by commas without spaces.<br>The currently supported categories can be found on <a href="https://www.cmsimple-xh.org/?Info-Repository#id5_available-categories-tags" target="_blank">this page</a>. You can add your own categories, but they cannot be sorted or filtered in the display. <span class="dataRequired">required</span></p>
</div>

<div class="xhFormGroup">
<label>XH Version</label>
<input value="<?=$compatibility?>" class="xhFormControl" type="text" name="compatibility" placeholder="e.g.: 1.7+" required>
<p class="xhFormHelp">For which CMSimple_XH version is your work suitable? <span class="dataRequired">required</span></p>
</div>

<div class="xhFormGroup">
<label>PHP Version</label>
<input value="<?=$php_ver?>" class="xhFormControl" type="text" name="php_ver" placeholder="e.g.: 5.6+" required>
<p class="xhFormHelp">Which PHP version is required? <span class="dataRequired">required</span></p>
</div>

<div class="xhFormGroup">
<label>License</label>
<input value="<?=$license?>" class="xhFormControl" type="text" name="license" placeholder="e.g.: GPLv3" required>
<p class="xhFormHelp">Under which license do you publish your work? If you make it freely available, just type <em>free</em>. <span class="dataRequired">required</span></p>
</div>

<div class="xhFormGroup">
<label>Demo URL</label>
<input value="<?=$demo_url?>" class="xhFormControl" type="url" name="demo_url" placeholder="e.g.: https://domain.tld?Demo">
<p class="xhFormHelp">Is there a demo? Enter here the address of a demo page or explanation page or leave it blank. <span class="dataRequired">optional</span></p>
</div>

<div class="xhFormGroup">
<label>Download URL</label>
<input value="<?=$download_url?>" class="xhFormControl" type="url" name="download_url" placeholder="e.g.: https://domain.tld/downloads/plugin_name.zip">
<p class="xhFormHelp">What is the download address? You can specify a direct download here, or an address to a download page or leave it blank. <span class="dataRequired">optional</span></p>
</div>

<div class="xhFormGroup">
<label>Programmer's name or nickname</label>
<input value="<?=$coder?>" class="xhFormControl" type="text" name="coder" placeholder="e.g.: John Doe" required>
<p class="xhFormHelp">Enter your own name here. If you want to remain incognito, then just your nickname. <span class="dataRequired">required</span></p>
</div>

<div class="xhFormGroup">
<label>Programmer's homepage</label>
<input value="<?=$coder_url?>" class="xhFormControl" type="url" name="coder_url" placeholder="e.g.: https://domain.tld">
<p class="xhFormHelp">Enter the address of your own homepage here or leave it blank. <span class="dataRequired">optional</span></p>
</div>

<div class="xhFormGroup">
<h2>2. Description</h2>
<p class="xhFormHelp">In the repo there are only the languages English <span class="dataRequired">required</span> and German <span class="dataRequired">optional</span>. If you also want to make your text available in other languages, then insert it here behind the English text. For example at the end of the english text: [SK] Lorem ipsum ...<br>
Only the following html tags are allowed: <b>&lt;br/&gt;</b> soft return, <b>&lt;ol&gt;</b> ordered list, <b>&lt;ul&gt;</b> unordered list, <b>&lt;li&gt;</b> list item, <b>&lt;b&gt;</b> bold, <b>&lt;i&gt;</b> italic. Please use the buttons in the editor. If the text contains illegal characters or code, the data is not processed further.</p>
<label>English description</label>
<p class="xhFormHelp">The english description is <span class="dataRequired">required !!!</span>. A maximum of 1000 characters is allowed.</p>
<textarea name="description_en" class="widgEditor nothing" maxlength="1000" placeholder="Your english text ..." required><?=$description_en?></textarea>
<label>German description</label>
<p class="xhFormHelp">The german description is <span class="dataRequired">optional</span>. A maximum of 1000 characters is allowed.</p>
<textarea name="description_de" class="widgEditor nothing" maxlength="1000" placeholder="Dein deutscher Text ..."><?=$description_de?></textarea>
</div>

<h2>3. Screenshots</h2>
<p class="xhFormHelp">You can attach up to 6 screenshots of your work here. Each image URL must have a description text (alt attribute). The images should have a maximum size of 1024 x 768px. Only images in <b>jpg</b>, <b>jpeg</b> or <b>png</b> format are allowed.<br>
Specifying the screenshot URLs is <span class="dataRequired">optional</span>. Please leave unneeded fields empty.</p>
<div class="xhFormInlinePart">
<div class="xhFormGroup">
<label>Screenshot URL 1</label>
<input value="<?=$screenshot1?>" class="xhFormControl w40" type="url" name="screenshot1" placeholder="https://domain.tld/img/screenshot-1.jpg">
</div>
<div class="xhFormGroup">
<label>Alternative text 1</label>
<input value="<?=$screenshotAlt1?>" class="xhFormControl w40" type="text" name="screenshotAlt1" placeholder="Alternative text for screenshot 1">
</div>
</div>
<div class="xhFormInlinePart">
<div class="xhFormGroup">
<label>Screenshot URL 2</label>
<input value="<?=$screenshot2?>" class="xhFormControl w40" type="url" name="screenshot2" placeholder="https://domain.tld/img/screenshot-2.jpg">
</div>
<div class="xhFormGroup">
<label>Alternative text 2</label>
<input value="<?=$screenshotAlt2?>" class="xhFormControl w40" type="text" name="screenshotAlt2" placeholder="Alternative text for screenshot 2">
</div>
</div>
<div class="xhFormInlinePart">
<div class="xhFormGroup">
<label>Screenshot URL 3</label>
<input value="<?=$screenshot3?>" class="xhFormControl w40" type="url" name="screenshot3" placeholder="https://domain.tld/img/screenshot-3.jpg">
</div>
<div class="xhFormGroup">
<label>Alternative text 3</label>
<input value="<?=$screenshotAlt3?>" class="xhFormControl w40" type="text" name="screenshotAlt3" placeholder="Alternative text for screenshot 3">
</div>
</div>
<div class="xhFormInlinePart">
<div class="xhFormGroup">
<label>Screenshot URL 4</label>
<input value="<?=$screenshot4?>" class="xhFormControl w40" type="url" name="screenshot4" placeholder="https://domain.tld/img/screenshot-4.jpg">
</div>
<div class="xhFormGroup">
<label>Alternative text 4</label>
<input value="<?=$screenshotAlt4?>" class="xhFormControl w40" type="text" name="screenshotAlt4" placeholder="Alternative text for screenshot 4">
</div>
</div>
<div class="xhFormInlinePart">
<div class="xhFormGroup">
<label>Screenshot URL 5</label>
<input value="<?=$screenshot5?>" class="xhFormControl w40" type="url" name="screenshot5" placeholder="https://domain.tld/img/screenshot-5.jpg">
</div>
<div class="xhFormGroup">
<label>Alternative text 5</label>
<input value="<?=$screenshotAlt5?>" class="xhFormControl w40" type="text" name="screenshotAlt5" placeholder="Alternative text for screenshot 5">
</div>
</div>
<div class="xhFormInlinePart">
<div class="xhFormGroup">
<label>Screenshot URL 6</label>
<input value="<?=$screenshot6?>" class="xhFormControl w40" type="url" name="screenshot6" placeholder="https://domain.tld/img/screenshot-6.jpg">
</div>
<div class="xhFormGroup">
<label>Alternative text 6</label>
<input value="<?=$screenshotAlt6?>" class="xhFormControl w40" type="text" name="screenshotAlt6" placeholder="Alternative text for screenshot 6">
</div>
</div>

<h2>4. Logo</h2>
<p class="xhFormHelp">You can attach a logo of your work here. If nothing is specified, a default logo is inserted. The image should have a minimum size of 100 x 100px and a maximum size of 200 x 200px (recommended). Only images in <b>jpg</b>, <b>jpeg</b>, <b>png</b>, <b>gif</b> or  <b>svg</b> format are allowed.<br>
Specifying the logo URLs is <span class="dataRequired">optional</span>. Please leave unneeded fields empty.</p>
<div class="xhFormGroup">
<label>Logo URL</label>
<input value="<?=$logo?>" class="xhFormControl" type="url" name="logo" placeholder="https://domain.tld/img/mylogo.jpg">
</div>

<h2>5. Finally</h2>
<div class="xhFormGroup">
<label>XML file URL</label>
<input value="<?=($xml_url != '' ? $xml_url : $xmlfolderURL)?>" class="xhFormControl" type="url" name="xml_url" placeholder="e.g.: https://domain.tld/download/" required>
<p class="xhFormHelp"><span class="dataRequired">required</span> Enter here the full path to your XML file (including 'http(s)://' at the beginning and '/' at the end) where it can be found later by the repo. It is sufficient to specify the path. The filename will be added automatically in the next step.</p>
</div>

<h2>Is everything all right now?</h2>
<p>Yes? Then let us &hellip;</p>
<input class="xhButtonLight" type="submit" name="submit" value="» WRITE the XML file" title="Note: Existing files will be overwritten without any further inquiry. However, a backup copy will be created.">
<p class="xhSmall">(Note: Existing files will be overwritten without any further inquiry. However, a backup copy will be created.)</p>
</form>
<p>&hellip; or &hellip;</p>
<p><a class="xhButtonLight" title="start with a new document" href="./">RESET all and start all over again</a></p>
</div>
</body>
</html>