<?php
/**
 * Copyright 2019 PaedDr. Martin Sereday [www.cmsimple.sk]
 *
 * xhRepo_xmlWriter
 * Version 1.6
 * creates XML-Files for teplad-xml-1.1
 *
 * xhRepo_xmlWriter is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * xhRepo_xmlWriter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. <http://www.gnu.org/licenses/>
 */
 
//error_reporting(E_ALL);
//ini_set('display_errors', 1);

//*****************************************************************************************************************************************
include_once('./config.php');
//*****************************************************************************************************************************************
function string_decode($post_string = '') {
    $post_string_tmp = html_entity_decode($post_string, ENT_QUOTES | ENT_HTML5, 'UTF-8');
    $post_string_tmp = str_replace(array('<', '>', '\'', '"', '&nbsp;'), array('&lt;', '&gt;', '', '', '&#160;'), $post_string_tmp);
    $post_string_tmp = preg_replace('/&(?!amp;)/', '&amp;', $post_string_tmp);
    $post_string_tmp = trim($post_string_tmp);
    return $post_string_tmp;
}
//*****************************************************************************************************************************************
// reads the $_POST data and puts it in php variables and fills it with data or N/A or let it blank
if(isset($_POST['name_type'])) {
    $name_type = $_POST['name_type'];
} else {
    $name_type = 'undefined';
}

if(isset($_POST['name'])) {
    $name = string_decode($_POST['name']);
} else {
    $name = 'undefined';
}

if(isset($_POST['version'])) {
    $version = string_decode($_POST['version']);
} else {
    $version = 'N/A';
}

if(isset($_POST['date_version'])) {
    $date_version = trim($_POST['date_version']);
} else {
    $date_version = 'N/A';
}

if(isset($_POST['tags'])) {
    $tags = string_decode($_POST['tags']);
} else {
    $tags = 'N/A';
}

if(isset($_POST['compatibility'])) {
    $compatibility = string_decode($_POST['compatibility']);
} else {
    $compatibility = 'N/A';
}

if(isset($_POST['php_ver'])) {
    $php_ver = string_decode($_POST['php_ver']);
} else {
    $php_ver = 'N/A';
}

if(isset($_POST['license'])) {
    $license = string_decode($_POST['license']);
} else {
    $license = 'N/A';
}

if(isset($_POST['demo_url'])) {
    $demo_url = string_decode($_POST['demo_url']);
} else {
    $demo_url = '';
}

if(isset($_POST['download_url'])) {
    $download_url = string_decode($_POST['download_url']);
} else {
    $download_url = '';
}

if(isset($_POST['coder'])) {
    $coder = string_decode($_POST['coder']);
} else {
    $coder = 'N/A';
}

if(isset($_POST['coder_url'])) {
    $coder_url = string_decode($_POST['coder_url']);
} else {
    $coder_url = '';
}

if(isset($_POST['description_en'])) {
    $description_en = str_replace('&nbsp;', '&#160;', $_POST['description_en']);
    $description_en = str_replace(array('<div>', '</div>', '&lt;div&gt;', '&lt;/div&gt;'), '', $description_en);
    $description_en = trim($description_en);
    if(substr($description_en, -6) == '<br />') {
        $description_en = substr($description_en, 0, -6);
    }
    if(substr($description_en, -12) == '&lt;br /&gt;') {
        $description_en = substr($description_en, 0, -12);
    }
} else {
    $description_en = 'No description available.';
}
if(isset($_POST['description_de'])) {
    $description_de = str_replace('&nbsp;', '&#160;', $_POST['description_de']);
    $description_de = str_replace(array('<div>', '</div>', '&lt;div&gt;', '&lt;/div&gt;'), '', $description_de);
    $description_de = trim($description_de);
    if(substr($description_de, -6) == '<br />') {
        $description_de = substr($description_de, 0, -6);
    }
    if(substr($description_de, -12) == '&lt;br /&gt;') {
        $description_de = substr($description_de, 0, -12);
    }
} else {
    $description_de = '';
}

if(isset($_POST['xml_url'])) {
    $xml_url = trim($_POST['xml_url']);
} else {
    $xml_url = '';
}

$date_update = date('Y-m-d');

if(isset($_POST['screenshot1'])) {
    $screenshot1 = string_decode($_POST['screenshot1']);
} else {
    $screenshot1 = '';
}
if(isset($_POST['screenshot2'])) {
    $screenshot2 = string_decode($_POST['screenshot2']);
} else {
    $screenshot2 = '';
}
if(isset($_POST['screenshot3'])) {
    $screenshot3 = string_decode($_POST['screenshot3']);
} else {
    $screenshot3 = '';
}
if(isset($_POST['screenshot4'])) {
    $screenshot4 = string_decode($_POST['screenshot4']);
} else {
    $screenshot4 = '';
}
if(isset($_POST['screenshot5'])) {
    $screenshot5 = string_decode($_POST['screenshot5']);
} else {
    $screenshot5 = '';
}
if(isset($_POST['screenshot6'])) {
    $screenshot6 = string_decode($_POST['screenshot6']);
} else {
    $screenshot6 = '';
}

if(isset($_POST['screenshotAlt1'])) {
    $screenshotAlt1 = string_decode($_POST['screenshotAlt1']);
} else {
    $screenshotAlt1 = '';
}
if(isset($_POST['screenshotAlt2'])) {
    $screenshotAlt2 = string_decode($_POST['screenshotAlt2']);
} else {
    $screenshotAlt2 = '';
}
if(isset($_POST['screenshotAlt3'])) {
    $screenshotAlt3 = string_decode($_POST['screenshotAlt3']);
} else {
    $screenshotAlt3 = '';
}
if(isset($_POST['screenshotAlt4'])) {
    $screenshotAlt4 = string_decode($_POST['screenshotAlt4']);
} else {
    $screenshotAlt4 = '';
}
if(isset($_POST['screenshotAlt5'])) {
    $screenshotAlt5 = string_decode($_POST['screenshotAlt5']);
} else {
    $screenshotAlt5 = '';
}
if(isset($_POST['screenshotAlt6'])) {
    $screenshotAlt6 = string_decode($_POST['screenshotAlt6']);
} else {
    $screenshotAlt6 = '';
}

if(isset($_POST['logo'])) {
    $logo = trim($_POST['logo']);
} else {
    $logo = '';
}
//******************************************************************************
// *** create filename ***
$xml_file_name_tmp = str_replace(array('Ä', 'Ö', 'Ü', 'ä', 'ö', 'ü', 'ß', '&amp;'),
                                 array('Ae', 'Oe', 'Ue', 'ae', 'oe', 'ue', 'ss', ''),
                                 $name);
$xml_file_name_tmp = strtolower($xml_file_name_tmp);
$xml_file_name_tmp = preg_replace('#[^a-z0-9-_]#i', '-', $xml_file_name_tmp);
$xml_file_name_tmp = preg_replace('#[-]{2,}#s', '-', $xml_file_name_tmp);
$xml_file_name = rtrim($xml_file_name_tmp, '-');
if($xml_file_name_prefix == 'on') {
    $data_xml = $name_type . '_' . $xml_file_name . '.xml';
    $data_html = $name_type . '_' . $xml_file_name . '.html';
} else {
    $data_xml = $xml_file_name . '.xml';
    $data_html = $xml_file_name . '.html';
}
// *** check xml-url ***
if(substr($xml_url, -4) != '.xml') {
    $full_xml_url = $xml_url . $data_xml;
} else {
    $full_xml_url = $xml_url;
}
//******************************************************************************
// *** create xml ***
$xml = new SimpleXMLElement('<teplad/>');
$dtd = '<?xml version="1.0" encoding="utf-8" standalone="yes"?>

<!DOCTYPE teplad [
    <!ELEMENT teplad (xml_url,name,date_update,version,date_version,coder,tags,url,compatibility,php_ver,license,descriptions,screenshots,logo) >
        <!ELEMENT url (download_url,coder_url,demo_url) >
        <!ELEMENT descriptions (description+) >
        <!ELEMENT screenshots (screenshot*) >
        
        <!ELEMENT xml_url            (#PCDATA) >
        <!ELEMENT name                (#PCDATA) >
        <!ELEMENT date_update        (#PCDATA) >
        <!ELEMENT version            (#PCDATA) >
        <!ELEMENT date_version        (#PCDATA) >
        <!ELEMENT coder                (#PCDATA) >
        <!ELEMENT tags                (#PCDATA) >
        <!ELEMENT compatibility        (#PCDATA) >
        <!ELEMENT php_ver            (#PCDATA) >
        <!ELEMENT license            (#PCDATA) >
        <!ELEMENT logo                (#PCDATA) >
        
        <!ELEMENT download_url        (#PCDATA) >
        <!ELEMENT coder_url            (#PCDATA) >
        <!ELEMENT demo_url            (#PCDATA) >
        <!ELEMENT description        (#PCDATA|br|ol|ul|li|i|b)* >
        <!ELEMENT br                    EMPTY >
        <!ELEMENT ol                    (li+) >
        <!ELEMENT ul                    (li+) >
        <!ELEMENT li                (#PCDATA) >
        <!ELEMENT i                    (#PCDATA) >
        <!ELEMENT b                    (#PCDATA) >
        <!ELEMENT screenshot        (#PCDATA) >
        
        <!ATTLIST teplad version CDATA    #REQUIRED >
        <!ATTLIST name type    (plugin|template|addon) #REQUIRED >
        <!ATTLIST description lang NMTOKEN    #REQUIRED >
        <!ATTLIST screenshot view CDATA        #REQUIRED >
]>
';
$xml->addAttribute('version', '1.1');
    $xml->addChild('xml_url', $full_xml_url);
    $name = $xml->addChild('name', $name);
    $name->addAttribute('type', $name_type);
    $xml->addChild('date_update', $date_update);
    $xml->addChild('version', $version);
    $xml->addChild('date_version', $date_version);
    $xml->addChild('coder', $coder);
    $xml->addChild('tags', $tags);
    $url = $xml->addChild('url');
        $url->addChild('download_url', $download_url);
        $url->addChild('coder_url', $coder_url);
        $url->addChild('demo_url', $demo_url);
    $xml->addChild('compatibility', $compatibility);
    $xml->addChild('php_ver', $php_ver);
    $xml->addChild('license', $license);
    $descriptions = $xml->addChild('descriptions');
        $description = $xml->descriptions->addChild('description', $description_en);
        $description->addAttribute('lang', 'en');
        if($description_de != '') {
            $description = $xml->descriptions->addChild('description', $description_de);
            $description->addAttribute('lang', 'de');
        }
    $screenshots = $xml->addChild('screenshots');
        if(($screenshot1 != '') && ($screenshotAlt1 != '')) {
            $screenshot = $xml->screenshots->addChild('screenshot', $screenshot1);
            $screenshot->addAttribute('view', $screenshotAlt1);
        }
        if(($screenshot2 != '') && ($screenshotAlt2 != '')) {
            $screenshot = $xml->screenshots->addChild('screenshot', $screenshot2);
            $screenshot->addAttribute('view', $screenshotAlt2);
        }
        if(($screenshot3 != '') && ($screenshotAlt3 != '')) {
            $screenshot = $xml->screenshots->addChild('screenshot', $screenshot3);
            $screenshot->addAttribute('view', $screenshotAlt3);
        }
        if(($screenshot4 != '') && ($screenshotAlt4 != '')) {
            $screenshot = $xml->screenshots->addChild('screenshot', $screenshot4);
            $screenshot->addAttribute('view', $screenshotAlt4);
        }
        if(($screenshot5 != '') && ($screenshotAlt5 != '')) {
            $screenshot = $xml->screenshots->addChild('screenshot', $screenshot5);
            $screenshot->addAttribute('view', $screenshotAlt5);
        }
        if(($screenshot6 != '') && ($screenshotAlt6 != '')) {
            $screenshot = $xml->screenshots->addChild('screenshot', $screenshot6);
            $screenshot->addAttribute('view', $screenshotAlt6);
        }
    $xml->addChild('logo', $logo);
//******************************************************************************
// *** write xml-file ***
$output_tmp = $xml->asXML();
$output_tmp = str_replace('<?xml version="1.0"?>', '', $output_tmp);
$output = $dtd . $output_tmp;
$write_xml_file = $xmlPath . '/' . $data_xml;
$fp = fopen($write_xml_file . '.tmp', 'w');
fputs($fp, $output);
fclose($fp);
if(file_exists($write_xml_file . '.tmp')) {
    if(file_exists($write_xml_file . '.bak')) {
        unlink($write_xml_file . '.bak');
    }
    if(file_exists($write_xml_file)) {
        rename($write_xml_file, $write_xml_file . '.bak');
    }
    rename($write_xml_file . '.tmp', $write_xml_file);
    chmod($write_xml_file, 0644);
}
//******************************************************************************
// *** html content ***
$html = '
<!DOCTYPE html>
<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Preview</title>
<meta http-equiv="cache-control" content="max-age=0" />
<meta http-equiv="cache-control" content="no-cache" />
<meta http-equiv="expires" content="0" />
<meta http-equiv="pragma" content="no-cache" />
<link href="../writer/css/stylesheet.css" rel="stylesheet" type="text/css">
</head>
<body class="preview">
<div class="xhXMLWriter">
<div class="xhLogo"> </div>
<p class="xhBigger">CMSimple_XH &ndash; Repo-XML-Writer</p>
<h1>Preview of the collected data</h1>
<p class="xhInfo">Here is a preview of how your data will arrive in the repo. The view is only similar.<br>
Check if all data, images and links are correct.</p>
<h2><span class="xhSmall"><span class="xhSmall">[' . $name_type . ']</span></span><br>
' . $name . '</h2>
<div class="repoxh_one_logo"><img src="' . ($logo != '' ? $logo : '../img/repo-logo-' . $name_type . '.svg') . '" alt="' . $name . ' Logo"></div>
<h3>Description [EN]</h3>
<div class="repoxh_one_desc">' . $description_en . '</div>
<h3>Description [DE]</h3>
<div class="repoxh_one_desc">' . $description_de . '</div>
<h3>Screenshots</h3>
<div class="repoxh_one_screen">';
if($screenshot1) { $html .= '<a href="' . $screenshot1 . '" ><img src="' . $screenshot1 . '" alt="' . $screenshotAlt1 . '"></a>'; }
if($screenshot2) { $html .= '<a href="' . $screenshot2 . '" ><img src="' . $screenshot2 . '" alt="' . $screenshotAlt2 . '"></a>'; }
if($screenshot3) { $html .= '<a href="' . $screenshot3 . '" ><img src="' . $screenshot3 . '" alt="' . $screenshotAlt3 . '"></a>'; }
if($screenshot4) { $html .= '<a href="' . $screenshot4 . '" ><img src="' . $screenshot4 . '" alt="' . $screenshotAlt4 . '"></a>'; }
if($screenshot5) { $html .= '<a href="' . $screenshot5 . '" ><img src="' . $screenshot5 . '" alt="' . $screenshotAlt5 . '"></a>'; }
if($screenshot6) { $html .= '<a href="' . $screenshot6 . '" ><img src="' . $screenshot6 . '" alt="' . $screenshotAlt6 . '"></a>'; }
$html .= '</div>';
if($demo_url) { $html .= '<div class="oneDemoUrl"><a class="xhButton" target="_blank" rel="noopener noreferrer" href="' . $demo_url . '">DEMO</a></div>';}
if($download_url) { $html .= '&nbsp;<div class="oneDownloadUrl"><a class="xhButton" href="' . $download_url . '" target="_blank">DOWNLOAD</a></div>';}
$html .= '
<ul class="repoxh_one_list">
<li><span>Category: </span>' . $tags . '</li>
<li><span>Current Version: </span>' . $version . '</li>
<li><span>Date of publication: </span>' . $date_version . '</li>
<li><span>XH-Version: </span>' . $compatibility . '</li>
<li><span>PHP-Version: </span>' . $php_ver . '</li>
<li><span>License: </span>' . $license . '</li>
<li><span>Coder: </span>' . $coder . '</li>
<li><span>Website: </span><a target="_blank" rel="noopener noreferrer" href="' . $coder_url . '">' . $coder_url . '</a></li>
<li><span>Information last updated on: </span>' . $date_update . '</li>
<li><span>XML url: </span>' . $full_xml_url . '</li>
</ul>
</div>
</body>
</html>
';

// *** write the html content ***
$write_html_file = $xmlPath . '/' . $data_html;
file_put_contents($write_html_file, $html);
if(file_exists($write_html_file)) {
    chmod($write_html_file, 0644);
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>CMSimple_XH XML-Writer</title>
<link href="css/stylesheet.css" rel="stylesheet" type="text/css">
</head>
<body>
<div class="xhXMLWriter">
<div class="xhLogo"> </div>
<h1>CMSimple_XH &ndash; Repo-XML-Writer <span>(Version 1.6)</span></h1>
<?php
echo '<p class="xhSuccess"><span class="xhBigger">Good job!</span><br>
Your file <strong>' . $data_xml . '</strong> was successfully created and saved in the folder "' . $xmlPath . '".</p>';
if(file_exists($write_xml_file)) {
    echo '
<p class="xhBigger"><br>Syntax error check</p>
<p>The XML document should now be checked again.<br>
To do this, click the following button:</p>
<form class="xmlcode">
<textarea class="xmlcode" name="xmlcode">' . htmlspecialchars(file_get_contents($write_xml_file)) . '</textarea>
<input title="copy the xml file to clipboard to validate it" class="xhButtonLight" type="button" value="Copy to clipboard" onClick="this.form.xmlcode.select(); this.form.xmlcode.focus(); document.execCommand(\'copy\')"><br>
</form>
<p>Now call the following address (opens in a new window) and paste it into the validator.</p>
<p><a title="to xml check" class="xhButtonLight" href="https://www.xmlvalidation.com/documentation.html" target="_blank">» https://www.xmlvalidation.com/documentation.html</a></p>
<p class="xhBigger"><br>Want a preview?</p>
<p>Okay. The following links will open in a new window.</p>
<p><a title="Preview of the pure XML file" class="xhButtonLight" href="' . $write_xml_file . '" target="_blank">» Prewiew of the pure XML file</a>&nbsp;<a title="Preview of the collected data" class="xhButtonLight" href="' . $write_html_file . '" target="_blank">» Preview of the collected data</a></p>
<h2>Is everything all right?</h2>
<p>Yes? Then you can make your work known to all people in the world.<br>
Visit the CMSimple_XH repository page and follow the instructions.</p>
<p><a class="xhButtonLight" title="To CMSimple_XH repository page" href="https://www.cmsimple-xh.org/?Info-Repository&advfrm-repository=' . $name_type . '&advfrm-url_xml_file=' . $full_xml_url . '&advfrm-name_nicname=' . $coder . '#id6_submit-plugin-or-template" target="_blank">» To CMSimple_XH repository page</a></p>
<p>or</p>
<p><a class="xhButtonLight" title="Back to the home page" href="./">« BACK to startpage</a></p>';
}
?>
</div>
</body>
</html>
